/* IMPORT */
import WorkerShim from 'web-worker';
import WorkerBackend from './backend_compiled.js';
/* MAIN */
class WorkerFrontend {
    /* CONSTRUCTOR */
    constructor(methods, name, listener) {
        const Worker = globalThis.Worker || WorkerShim; // Ensuring Electron is supported
        const code = `data:text/javascript;charset=utf-8,${encodeURIComponent(WorkerBackend.replace('/*! METHODS_PLACEHOLDER !*/', `\n\n\n${methods}`))}`; //TODO: Use Blobs instead, maybe
        this.worker = new Worker(code, { name, type: 'module' });
        this.listen(listener);
    }
    /* API */
    listen(listener) {
        this.worker.addEventListener('message', event => listener(event.data));
    }
    send(message) {
        this.worker.postMessage(message);
    }
    terminate() {
        this.worker.terminate();
    }
}
/* EXPORT */
export default WorkerFrontend;
